]> git.ipfire.org Git - thirdparty/git.git/blame - git-rebase--interactive.sh
t9810: Do not use sed -i
[thirdparty/git.git] / git-rebase--interactive.sh
CommitLineData
1b1dce4b
JS
1#!/bin/sh
2#
3# Copyright (c) 2006 Johannes E. Schindelin
4
5# SHORT DESCRIPTION
6#
7# This script makes it easy to fix up commits in the middle of a series,
8# and rearrange commits.
9#
10# The original idea comes from Eric W. Biederman, in
11# http://article.gmane.org/gmane.comp.version-control.git/22407
572a7c52 12#
80883bb3
MH
13# The file containing rebase commands, comments, and empty lines.
14# This file is created by "git rebase -i" then edited by the user. As
15# the lines are processed, they are removed from the front of this
6bb4e485 16# file and written to the tail of $done.
431b7e78 17todo="$state_dir"/git-rebase-todo
80883bb3
MH
18
19# The rebase command lines that have already been processed. A line
20# is moved here when it is first handled, before any associated user
21# actions.
431b7e78 22done="$state_dir"/done
80883bb3
MH
23
24# The commit message that is planned to be used for any changes that
25# need to be committed following a user interaction.
431b7e78 26msg="$state_dir"/message
80883bb3
MH
27
28# The file into which is accumulated the suggested commit message for
29# squash/fixup commands. When the first of a series of squash/fixups
30# is seen, the file is created and the commit message from the
31# previous commit and from the first squash/fixup commit are written
32# to it. The commit message for each subsequent squash/fixup commit
33# is appended to the file as it is processed.
34#
35# The first line of the file is of the form
6bb4e485
MZ
36# # This is a combination of $count commits.
37# where $count is the number of commits whose messages have been
80883bb3
MH
38# written to the file so far (including the initial "pick" commit).
39# Each time that a commit message is processed, this line is read and
40# updated. It is deleted just before the combined commit is made.
431b7e78 41squash_msg="$state_dir"/message-squash
80883bb3 42
a25eb139
MH
43# If the current series of squash/fixups has not yet included a squash
44# command, then this file exists and holds the commit message of the
45# original "pick" commit. (If the series ends without a "squash"
46# command, then this can be used as the commit message of the combined
47# commit without opening the editor.)
431b7e78 48fixup_msg="$state_dir"/message-fixup
a25eb139 49
6bb4e485
MZ
50# $rewritten is the name of a directory containing files for each
51# commit that is reachable by at least one merge base of $head and
52# $upstream. They are not necessarily rewritten, but their children
80883bb3
MH
53# might be. This ensures that commits on merged, but otherwise
54# unrelated side branches are left alone. (Think "X" in the man page's
55# example.)
431b7e78 56rewritten="$state_dir"/rewritten
80883bb3 57
431b7e78 58dropped="$state_dir"/dropped
0aac0de4
MH
59
60# A script to set the GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
61# GIT_AUTHOR_DATE that will be used for the commit that is currently
62# being rebased.
431b7e78 63author_script="$state_dir"/author-script
0aac0de4 64
a4049ae7
MH
65# When an "edit" rebase command is being processed, the SHA1 of the
66# commit to be edited is recorded in this file. When "git rebase
67# --continue" is executed, if there are any staged changes then they
68# will be amended to the HEAD commit, but only provided the HEAD
69# commit is still the commit to be edited. When any other rebase
70# command is processed, this file is deleted.
431b7e78 71amend="$state_dir"/amend
a4049ae7 72
b079feed
TR
73# For the post-rewrite hook, we make a list of rewritten commits and
74# their new sha1s. The rewritten-pending list keeps the sha1s of
75# commits that have been processed, but not committed yet,
76# e.g. because they are waiting for a 'squash' command.
431b7e78
MZ
77rewritten_list="$state_dir"/rewritten-list
78rewritten_pending="$state_dir"/rewritten-pending
6bb4e485 79
89c7ae9c 80GIT_CHERRY_PICK_HELP="$resolvemsg"
804c7174
WC
81export GIT_CHERRY_PICK_HELP
82
1b1dce4b 83warn () {
938791cd 84 printf '%s\n' "$*" >&2
1b1dce4b
JS
85}
86
ee0a4afb
MH
87# Output the commit message for the specified commit.
88commit_message () {
89 git cat-file commit "$1" | sed "1,/^$/d"
90}
91
6bb4e485 92orig_reflog_action="$GIT_REFLOG_ACTION"
1b1dce4b
JS
93
94comment_for_reflog () {
6bb4e485 95 case "$orig_reflog_action" in
1b1dce4b
JS
96 ''|rebase*)
97 GIT_REFLOG_ACTION="rebase -i ($1)"
98 export GIT_REFLOG_ACTION
376ccb8c 99 ;;
1b1dce4b
JS
100 esac
101}
102
4e673877 103last_count=
1b1dce4b 104mark_action_done () {
6bb4e485
MZ
105 sed -e 1q < "$todo" >> "$done"
106 sed -e 1d < "$todo" >> "$todo".new
107 mv -f "$todo".new "$todo"
108 new_count=$(sane_grep -c '^[^#]' < "$done")
109 total=$(($new_count+$(sane_grep -c '^[^#]' < "$todo")))
110 if test "$last_count" != "$new_count"
4e673877 111 then
6bb4e485
MZ
112 last_count=$new_count
113 printf "Rebasing (%d/%d)\r" $new_count $total
114 test -z "$verbose" || echo
4e673877 115 fi
1b1dce4b
JS
116}
117
fcc5ef1c
AW
118append_todo_help () {
119 cat >> "$todo" << EOF
120#
121# Commands:
122# p, pick = use commit
123# r, reword = use commit, but edit the commit message
124# e, edit = use commit, but stop for amending
125# s, squash = use commit, but meld into previous commit
126# f, fixup = like "squash", but discard this commit's log message
127# x, exec = run command (the rest of the line) using shell
128#
129# These lines can be re-ordered; they are executed from top to bottom.
130#
131# If you remove a line here THAT COMMIT WILL BE LOST.
132EOF
133}
134
1b1dce4b 135make_patch () {
4fb1a19d
JS
136 sha1_and_parents="$(git rev-list --parents -1 "$1")"
137 case "$sha1_and_parents" in
138 ?*' '?*' '?*)
139 git diff --cc $sha1_and_parents
140 ;;
141 ?*' '?*)
142 git diff-tree -p "$1^!"
143 ;;
144 *)
145 echo "Root commit"
146 ;;
431b7e78 147 esac > "$state_dir"/patch
6bb4e485
MZ
148 test -f "$msg" ||
149 commit_message "$1" > "$msg"
150 test -f "$author_script" ||
151 get_author_ident_from_commit "$1" > "$author_script"
1b1dce4b
JS
152}
153
154die_with_patch () {
431b7e78 155 echo "$1" > "$state_dir"/stopped-sha
1b1dce4b 156 make_patch "$1"
ecfe72ff 157 git rerere
1b1dce4b
JS
158 die "$2"
159}
160
0becb3e4
AW
161exit_with_patch () {
162 echo "$1" > "$state_dir"/stopped-sha
163 make_patch $1
164 git rev-parse --verify HEAD > "$amend"
165 warn "You can amend the commit now, with"
166 warn
167 warn " git commit --amend"
168 warn
169 warn "Once you are satisfied with your changes, run"
170 warn
171 warn " git rebase --continue"
172 warn
173 exit $2
174}
175
c54b7817 176die_abort () {
431b7e78 177 rm -rf "$state_dir"
c54b7817
JS
178 die "$1"
179}
180
376ccb8c 181has_action () {
e1622bfc 182 sane_grep '^[^#]' "$1" >/dev/null
376ccb8c
JS
183}
184
90e1818f
NH
185is_empty_commit() {
186 tree=$(git rev-parse -q --verify "$1"^{tree} 2>/dev/null ||
187 die "$1: not a commit that can be picked")
188 ptree=$(git rev-parse -q --verify "$1"^^{tree} 2>/dev/null ||
189 ptree=4b825dc642cb6eb9a060e54bf8d69288fbee4904)
190 test "$tree" = "$ptree"
191}
192
7756ecff
MH
193# Run command with GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
194# GIT_AUTHOR_DATE exported from the current environment.
195do_with_author () {
76c9c0db
JH
196 (
197 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
198 "$@"
199 )
7756ecff
MH
200}
201
821881d8
PO
202git_sequence_editor () {
203 if test -z "$GIT_SEQUENCE_EDITOR"
204 then
205 GIT_SEQUENCE_EDITOR="$(git config sequence.editor)"
206 if [ -z "$GIT_SEQUENCE_EDITOR" ]
207 then
208 GIT_SEQUENCE_EDITOR="$(git var GIT_EDITOR)" || return $?
209 fi
210 fi
211
212 eval "$GIT_SEQUENCE_EDITOR" '"$@"'
213}
214
1b1dce4b 215pick_one () {
8e75abfd 216 ff=--ff
90e1818f 217
8e75abfd 218 case "$1" in -n) sha1=$2; ff= ;; *) sha1=$1 ;; esac
6bb4e485 219 case "$force_rebase" in '') ;; ?*) ff= ;; esac
dfa49f33 220 output git rev-parse --verify $sha1 || die "Invalid commit name: $sha1"
90e1818f
NH
221
222 if is_empty_commit "$sha1"
223 then
224 empty_args="--allow-empty"
225 fi
226
6bb4e485 227 test -d "$rewritten" &&
f09c9b8c 228 pick_one_preserving_merges "$@" && return
90e1818f 229 output git cherry-pick $empty_args $ff "$@"
1b1dce4b
JS
230}
231
f09c9b8c 232pick_one_preserving_merges () {
71d9451e
TR
233 fast_forward=t
234 case "$1" in
235 -n)
236 fast_forward=f
237 sha1=$2
238 ;;
239 *)
240 sha1=$1
241 ;;
242 esac
f09c9b8c
JS
243 sha1=$(git rev-parse $sha1)
244
431b7e78 245 if test -f "$state_dir"/current-commit
f09c9b8c 246 then
4c1360f4 247 if test "$fast_forward" = t
bb645071 248 then
41f556b9 249 while read current_commit
bb645071 250 do
6bb4e485 251 git rev-parse HEAD > "$rewritten"/$current_commit
431b7e78
MZ
252 done <"$state_dir"/current-commit
253 rm "$state_dir"/current-commit ||
bb645071
SH
254 die "Cannot write current commit's replacement sha1"
255 fi
f09c9b8c
JS
256 fi
257
431b7e78 258 echo $sha1 >> "$state_dir"/current-commit
a96dc01e 259
f09c9b8c 260 # rewrite parents; if none were rewritten, we can fast-forward.
f09c9b8c 261 new_parents=
d911d146
TR
262 pend=" $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)"
263 if test "$pend" = " "
264 then
265 pend=" root"
266 fi
faae853c 267 while [ "$pend" != "" ]
f09c9b8c 268 do
faae853c
SH
269 p=$(expr "$pend" : ' \([^ ]*\)')
270 pend="${pend# $p}"
271
6bb4e485 272 if test -f "$rewritten"/$p
f09c9b8c 273 then
6bb4e485 274 new_p=$(cat "$rewritten"/$p)
80fe82e4
SH
275
276 # If the todo reordered commits, and our parent is marked for
277 # rewriting, but hasn't been gotten to yet, assume the user meant to
278 # drop it on top of the current HEAD
279 if test -z "$new_p"
280 then
281 new_p=$(git rev-parse HEAD)
282 fi
283
f09c9b8c
JS
284 test $p != $new_p && fast_forward=f
285 case "$new_parents" in
286 *$new_p*)
287 ;; # do nothing; that parent is already there
288 *)
289 new_parents="$new_parents $new_p"
376ccb8c 290 ;;
f09c9b8c 291 esac
1c5fa0a1 292 else
6bb4e485 293 if test -f "$dropped"/$p
faae853c
SH
294 then
295 fast_forward=f
6bb4e485 296 replacement="$(cat "$dropped"/$p)"
d911d146
TR
297 test -z "$replacement" && replacement=root
298 pend=" $replacement$pend"
faae853c
SH
299 else
300 new_parents="$new_parents $p"
301 fi
f09c9b8c
JS
302 fi
303 done
304 case $fast_forward in
305 t)
a75d7b54 306 output warn "Fast-forward to $sha1"
71d9451e 307 output git reset --hard $sha1 ||
a75d7b54 308 die "Cannot fast-forward to $sha1"
f09c9b8c
JS
309 ;;
310 f)
376ccb8c 311 first_parent=$(expr "$new_parents" : ' \([^ ]*\)')
a4f25e36
SH
312
313 if [ "$1" != "-n" ]
314 then
315 # detach HEAD to current parent
316 output git checkout $first_parent 2> /dev/null ||
317 die "Cannot move HEAD to $first_parent"
318 fi
f09c9b8c 319
f09c9b8c 320 case "$new_parents" in
376ccb8c 321 ' '*' '*)
a4f25e36
SH
322 test "a$1" = a-n && die "Refusing to squash a merge: $sha1"
323
f09c9b8c 324 # redo merge
6bb4e485
MZ
325 author_script_content=$(get_author_ident_from_commit $sha1)
326 eval "$author_script_content"
327 msg_content="$(commit_message $sha1)"
f91333d6
BS
328 # No point in merging the first parent, that's HEAD
329 new_parents=${new_parents# $first_parent}
7756ecff 330 if ! do_with_author output \
9fdc1cc8 331 git merge --no-ff ${strategy:+-s $strategy} -m \
9765b6ab 332 "$msg_content" $new_parents
f09c9b8c 333 then
6bb4e485 334 printf "%s\n" "$msg_content" > "$GIT_DIR"/MERGE_MSG
f5b49ea6 335 die_with_patch $sha1 "Error redoing merge $sha1"
f09c9b8c 336 fi
6bb4e485 337 echo "$sha1 $(git rev-parse HEAD^0)" >> "$rewritten_list"
f09c9b8c
JS
338 ;;
339 *)
2a9c53e0 340 output git cherry-pick "$@" ||
f09c9b8c 341 die_with_patch $sha1 "Could not pick $sha1"
376ccb8c 342 ;;
f09c9b8c 343 esac
376ccb8c 344 ;;
f09c9b8c
JS
345 esac
346}
347
6368f3f8
JS
348nth_string () {
349 case "$1" in
350 *1[0-9]|*[04-9]) echo "$1"th;;
351 *1) echo "$1"st;;
352 *2) echo "$1"nd;;
353 *3) echo "$1"rd;;
354 esac
355}
356
a25eb139 357update_squash_messages () {
6bb4e485
MZ
358 if test -f "$squash_msg"; then
359 mv "$squash_msg" "$squash_msg".bak || exit
360 count=$(($(sed -n \
f99e269c 361 -e "1s/^# This is a combination of \(.*\) commits\./\1/p" \
6bb4e485 362 -e "q" < "$squash_msg".bak)+1))
bde1a686 363 {
6bb4e485 364 echo "# This is a combination of $count commits."
bde1a686
MH
365 sed -e 1d -e '2,/^./{
366 /^$/d
6bb4e485
MZ
367 }' <"$squash_msg".bak
368 } >"$squash_msg"
6368f3f8 369 else
6bb4e485
MZ
370 commit_message HEAD > "$fixup_msg" || die "Cannot write $fixup_msg"
371 count=2
bde1a686
MH
372 {
373 echo "# This is a combination of 2 commits."
374 echo "# The first commit's message is:"
375 echo
6bb4e485
MZ
376 cat "$fixup_msg"
377 } >"$squash_msg"
6368f3f8 378 fi
0205e72f
MH
379 case $1 in
380 squash)
6bb4e485 381 rm -f "$fixup_msg"
0205e72f 382 echo
6bb4e485 383 echo "# This is the $(nth_string $count) commit message:"
0205e72f 384 echo
ee0a4afb 385 commit_message $2
0205e72f
MH
386 ;;
387 fixup)
388 echo
6bb4e485 389 echo "# The $(nth_string $count) commit message will be skipped:"
0205e72f 390 echo
ee0a4afb 391 commit_message $2 | sed -e 's/^/# /'
0205e72f 392 ;;
6bb4e485 393 esac >>"$squash_msg"
6368f3f8
JS
394}
395
396peek_next_command () {
6bb4e485 397 sed -n -e "/^#/d" -e '/^$/d' -e "s/ .*//p" -e "q" < "$todo"
6368f3f8
JS
398}
399
6bdcd0d2
MH
400# A squash/fixup has failed. Prepare the long version of the squash
401# commit message, then die_with_patch. This code path requires the
402# user to edit the combined commit message for all commits that have
403# been squashed/fixedup so far. So also erase the old squash
404# messages, effectively causing the combined commit to be used as the
405# new basis for any further squash/fixups. Args: sha1 rest
406die_failed_squash() {
6bb4e485
MZ
407 mv "$squash_msg" "$msg" || exit
408 rm -f "$fixup_msg"
409 cp "$msg" "$GIT_DIR"/MERGE_MSG || exit
6bdcd0d2
MH
410 warn
411 warn "Could not apply $1... $2"
412 die_with_patch $1 ""
413}
414
b079feed 415flush_rewritten_pending() {
6bb4e485 416 test -s "$rewritten_pending" || return
b079feed 417 newsha1="$(git rev-parse HEAD^0)"
6bb4e485
MZ
418 sed "s/$/ $newsha1/" < "$rewritten_pending" >> "$rewritten_list"
419 rm -f "$rewritten_pending"
b079feed
TR
420}
421
422record_in_rewritten() {
423 oldsha1="$(git rev-parse $1)"
6bb4e485 424 echo "$oldsha1" >> "$rewritten_pending"
b079feed
TR
425
426 case "$(peek_next_command)" in
41f556b9 427 squash|s|fixup|f)
b079feed 428 ;;
41f556b9 429 *)
b079feed
TR
430 flush_rewritten_pending
431 ;;
432 esac
433}
434
df5df20c
CW
435do_pick () {
436 if test "$(git rev-parse HEAD)" = "$squash_onto"
437 then
438 # Set the correct commit message and author info on the
439 # sentinel root before cherry-picking the original changes
440 # without committing (-n). Finally, update the sentinel again
441 # to include these changes. If the cherry-pick results in a
442 # conflict, this means our behaviour is similar to a standard
443 # failed cherry-pick during rebase, with a dirty index to
444 # resolve before manually running git commit --amend then git
445 # rebase --continue.
446 git commit --allow-empty --allow-empty-message --amend \
447 --no-post-rewrite -n -q -C $1 &&
448 pick_one -n $1 &&
449 git commit --allow-empty --allow-empty-message \
450 --amend --no-post-rewrite -n -q -C $1 ||
451 die_with_patch $1 "Could not apply $1... $2"
452 else
453 pick_one $1 ||
454 die_with_patch $1 "Could not apply $1... $2"
455 fi
456}
457
1b1dce4b 458do_next () {
6bb4e485
MZ
459 rm -f "$msg" "$author_script" "$amend" || exit
460 read -r command sha1 rest < "$todo"
1b1dce4b 461 case "$command" in
ff74126c 462 '#'*|''|noop)
1b1dce4b 463 mark_action_done
1b1dce4b 464 ;;
f8babc4d 465 pick|p)
1b1dce4b
JS
466 comment_for_reflog pick
467
468 mark_action_done
df5df20c 469 do_pick $sha1 "$rest"
b079feed 470 record_in_rewritten $sha1
1b1dce4b 471 ;;
6741aa6c
BG
472 reword|r)
473 comment_for_reflog reword
474
475 mark_action_done
df5df20c 476 do_pick $sha1 "$rest"
0becb3e4
AW
477 git commit --amend --no-post-rewrite || {
478 warn "Could not amend commit after successfully picking $sha1... $rest"
479 warn "This is most likely due to an empty commit message, or the pre-commit hook"
480 warn "failed. If the pre-commit hook failed, you may need to resolve the issue before"
481 warn "you are able to reword the commit."
482 exit_with_patch $sha1 1
483 }
b079feed 484 record_in_rewritten $sha1
6741aa6c 485 ;;
f8babc4d 486 edit|e)
1b1dce4b
JS
487 comment_for_reflog edit
488
489 mark_action_done
df5df20c 490 do_pick $sha1 "$rest"
a8ccc204 491 warn "Stopped at $sha1... $rest"
0becb3e4 492 exit_with_patch $sha1 0
1b1dce4b 493 ;;
0205e72f
MH
494 squash|s|fixup|f)
495 case "$command" in
496 squash|s)
497 squash_style=squash
498 ;;
499 fixup|f)
500 squash_style=fixup
501 ;;
502 esac
503 comment_for_reflog $squash_style
1b1dce4b 504
6bb4e485 505 test -f "$done" && has_action "$done" ||
0205e72f 506 die "Cannot '$squash_style' without a previous commit"
1b1dce4b
JS
507
508 mark_action_done
a25eb139 509 update_squash_messages $squash_style $sha1
6bb4e485
MZ
510 author_script_content=$(get_author_ident_from_commit HEAD)
511 echo "$author_script_content" > "$author_script"
512 eval "$author_script_content"
2147f844
CW
513 if ! pick_one -n $sha1
514 then
515 git rev-parse --verify HEAD >"$amend"
516 die_failed_squash $sha1 "$rest"
517 fi
6368f3f8 518 case "$(peek_next_command)" in
0205e72f 519 squash|s|fixup|f)
a25eb139
MH
520 # This is an intermediate commit; its message will only be
521 # used in case of trouble. So use the long version:
2147f844 522 do_with_author output git commit --amend --no-verify -F "$squash_msg" ||
6bdcd0d2 523 die_failed_squash $sha1 "$rest"
376ccb8c 524 ;;
6368f3f8 525 *)
a25eb139 526 # This is the final command of this squash/fixup group
6bb4e485 527 if test -f "$fixup_msg"
a25eb139 528 then
2147f844 529 do_with_author git commit --amend --no-verify -F "$fixup_msg" ||
6bdcd0d2
MH
530 die_failed_squash $sha1 "$rest"
531 else
6bb4e485 532 cp "$squash_msg" "$GIT_DIR"/SQUASH_MSG || exit
6bdcd0d2 533 rm -f "$GIT_DIR"/MERGE_MSG
2147f844 534 do_with_author git commit --amend --no-verify -F "$GIT_DIR"/SQUASH_MSG -e ||
6bdcd0d2 535 die_failed_squash $sha1 "$rest"
a25eb139 536 fi
6bb4e485 537 rm -f "$squash_msg" "$fixup_msg"
376ccb8c 538 ;;
6368f3f8 539 esac
b079feed 540 record_in_rewritten $sha1
1b1dce4b 541 ;;
cd035b1c 542 x|"exec")
6bb4e485 543 read -r command rest < "$todo"
cd035b1c
MM
544 mark_action_done
545 printf 'Executing: %s\n' "$rest"
546 # "exec" command doesn't take a sha1 in the todo-list.
547 # => can't just use $sha1 here.
431b7e78 548 git rev-parse --verify HEAD > "$state_dir"/stopped-sha
cd035b1c
MM
549 ${SHELL:-@SHELL_PATH@} -c "$rest" # Actual execution
550 status=$?
1686519a
JH
551 # Run in subshell because require_clean_work_tree can die.
552 dirty=f
553 (require_clean_work_tree "rebase" 2>/dev/null) || dirty=t
cd035b1c
MM
554 if test "$status" -ne 0
555 then
556 warn "Execution failed: $rest"
1686519a
JH
557 test "$dirty" = f ||
558 warn "and made changes to the index and/or the working tree"
559
cd035b1c
MM
560 warn "You can fix the problem, and then run"
561 warn
562 warn " git rebase --continue"
563 warn
ecfe1ea9
JS
564 if test $status -eq 127 # command not found
565 then
566 status=1
567 fi
cd035b1c 568 exit "$status"
1686519a 569 elif test "$dirty" = t
cd035b1c 570 then
1686519a
JH
571 warn "Execution succeeded: $rest"
572 warn "but left changes to the index and/or the working tree"
cd035b1c
MM
573 warn "Commit or stash your changes, and then run"
574 warn
575 warn " git rebase --continue"
576 warn
577 exit 1
578 fi
579 ;;
1b1dce4b
JS
580 *)
581 warn "Unknown command: $command $sha1 $rest"
9c8e1011 582 fixtodo="Please fix this using 'git rebase --edit-todo'."
f1be316a
JK
583 if git rev-parse --verify -q "$sha1" >/dev/null
584 then
9c8e1011 585 die_with_patch $sha1 "$fixtodo"
f1be316a 586 else
9c8e1011 587 die "$fixtodo"
f1be316a 588 fi
376ccb8c 589 ;;
1b1dce4b 590 esac
6bb4e485 591 test -s "$todo" && return
1b1dce4b 592
68a163c9 593 comment_for_reflog finish &&
6bb4e485 594 newhead=$(git rev-parse HEAD) &&
431b7e78 595 case $head_name in
73697a0b 596 refs/*)
1af221ef 597 message="$GIT_REFLOG_ACTION: $head_name onto $onto" &&
431b7e78 598 git update-ref -m "$message" $head_name $newhead $orig_head &&
53f2ffa8
JK
599 git symbolic-ref \
600 -m "$GIT_REFLOG_ACTION: returning to $head_name" \
601 HEAD $head_name
73697a0b
JS
602 ;;
603 esac && {
431b7e78 604 test ! -f "$state_dir"/verbose ||
2959c283 605 git diff-tree --stat $orig_head..HEAD
3df0a859 606 } &&
eb2151bb 607 {
6bb4e485
MZ
608 test -s "$rewritten_list" &&
609 git notes copy --for-rewrite=rebase < "$rewritten_list" ||
eb2151bb
TR
610 true # we don't care if this copying failed
611 } &&
b079feed 612 if test -x "$GIT_DIR"/hooks/post-rewrite &&
6bb4e485
MZ
613 test -s "$rewritten_list"; then
614 "$GIT_DIR"/hooks/post-rewrite rebase < "$rewritten_list"
b079feed
TR
615 true # we don't care if this hook failed
616 fi &&
431b7e78 617 rm -rf "$state_dir" &&
73697a0b 618 git gc --auto &&
431b7e78 619 warn "Successfully rebased and updated $head_name."
1b1dce4b
JS
620
621 exit
622}
623
624do_rest () {
625 while :
626 do
627 do_next
628 done
1b1dce4b
JS
629}
630
0e757e30
JS
631# skip picking commits whose parents are unchanged
632skip_unnecessary_picks () {
633 fd=3
2d6ca6ef 634 while read -r command rest
0e757e30
JS
635 do
636 # fd=3 means we skip the command
2d6ca6ef
BC
637 case "$fd,$command" in
638 3,pick|3,p)
6bb4e485 639 # pick a commit whose parent is current $onto -> skip
14d87298 640 sha1=${rest%% *}
2d6ca6ef 641 case "$(git rev-parse --verify --quiet "$sha1"^)" in
6bb4e485
MZ
642 "$onto"*)
643 onto=$sha1
2d6ca6ef
BC
644 ;;
645 *)
646 fd=1
647 ;;
648 esac
0e757e30 649 ;;
2d6ca6ef 650 3,#*|3,)
0e757e30
JS
651 # copy comments
652 ;;
653 *)
654 fd=1
655 ;;
656 esac
d1c3b10f 657 printf '%s\n' "$command${rest:+ }$rest" >&$fd
6bb4e485
MZ
658 done <"$todo" >"$todo.new" 3>>"$done" &&
659 mv -f "$todo".new "$todo" &&
b079feed
TR
660 case "$(peek_next_command)" in
661 squash|s|fixup|f)
6bb4e485 662 record_in_rewritten "$onto"
b079feed
TR
663 ;;
664 esac ||
0e757e30
JS
665 die "Could not skip unnecessary pick commands"
666}
667
f59baa50
NS
668# Rearrange the todo list that has both "pick sha1 msg" and
669# "pick sha1 fixup!/squash! msg" appears in it so that the latter
670# comes immediately after the former, and change "pick" to
671# "fixup"/"squash".
672rearrange_squash () {
68d5d03b
KB
673 # extract fixup!/squash! lines and resolve any referenced sha1's
674 while read -r pick sha1 message
675 do
676 case "$message" in
677 "squash! "*|"fixup! "*)
678 action="${message%%!*}"
679 rest="${message#*! }"
680 echo "$sha1 $action $rest"
681 # if it's a single word, try to resolve to a full sha1 and
682 # emit a second copy. This allows us to match on both message
683 # and on sha1 prefix
684 if test "${rest#* }" = "$rest"; then
685 fullsha="$(git rev-parse -q --verify "$rest" 2>/dev/null)"
686 if test -n "$fullsha"; then
687 # prefix the action to uniquely identify this line as
688 # intended for full sha1 match
689 echo "$sha1 +$action $fullsha"
690 fi
691 fi
692 esac
693 done >"$1.sq" <"$1"
f59baa50
NS
694 test -s "$1.sq" || return
695
696 used=
57f2b6b2 697 while read -r pick sha1 message
f59baa50
NS
698 do
699 case " $used" in
700 *" $sha1 "*) continue ;;
701 esac
938791cd 702 printf '%s\n' "$pick $sha1 $message"
d3d7a421 703 used="$used$sha1 "
6bb4e485 704 while read -r squash action msg_content
f59baa50 705 do
d3d7a421
KB
706 case " $used" in
707 *" $squash "*) continue ;;
708 esac
68d5d03b
KB
709 emit=0
710 case "$action" in
711 +*)
712 action="${action#+}"
713 # full sha1 prefix test
6bb4e485 714 case "$msg_content" in "$sha1"*) emit=1;; esac ;;
68d5d03b
KB
715 *)
716 # message prefix test
6bb4e485 717 case "$message" in "$msg_content"*) emit=1;; esac ;;
68d5d03b
KB
718 esac
719 if test $emit = 1; then
6bb4e485 720 printf '%s\n' "$action $squash $action! $msg_content"
f59baa50 721 used="$used$squash "
68d5d03b 722 fi
f59baa50
NS
723 done <"$1.sq"
724 done >"$1.rearranged" <"$1"
725 cat "$1.rearranged" >"$1"
726 rm -f "$1.sq" "$1.rearranged"
727}
728
c2145384
LK
729# Add commands after a pick or after a squash/fixup serie
730# in the todo list.
731add_exec_commands () {
732 {
733 first=t
734 while read -r insn rest
735 do
736 case $insn in
737 pick)
738 test -n "$first" ||
739 printf "%s" "$cmd"
740 ;;
741 esac
742 printf "%s %s\n" "$insn" "$rest"
743 first=
744 done
745 printf "%s" "$cmd"
746 } <"$1" >"$1.new" &&
747 mv "$1.new" "$1"
748}
749
cf432ca0
MZ
750case "$action" in
751continue)
cf432ca0 752 # do we have anything to commit?
a6754cda 753 if git diff-index --cached --quiet HEAD --
cf432ca0
MZ
754 then
755 : Nothing to commit -- skip this
756 else
ffaaed88
MM
757 if ! test -f "$author_script"
758 then
759 die "You have staged changes in your working tree. If these changes are meant to be
760squashed into the previous commit, run:
761
762 git commit --amend
763
764If they are meant to go into a new commit, run:
765
766 git commit
767
768In both case, once you're done, continue with:
769
770 git rebase --continue
771"
772 fi
cf432ca0 773 . "$author_script" ||
ffaaed88 774 die "Error trying to find the author identity to amend commit"
cf432ca0 775 if test -f "$amend"
03270628 776 then
cf432ca0
MZ
777 current_head=$(git rev-parse --verify HEAD)
778 test "$current_head" = $(cat "$amend") ||
779 die "\
c14c3c82
DP
780You have uncommitted changes in your working tree. Please, commit them
781first and then run 'git rebase --continue' again."
2147f844
CW
782 do_with_author git commit --amend --no-verify -F "$msg" -e ||
783 die "Could not commit staged changes."
784 else
785 do_with_author git commit --no-verify -F "$msg" -e ||
786 die "Could not commit staged changes."
03270628 787 fi
cf432ca0 788 fi
18640d99 789
431b7e78 790 record_in_rewritten "$(cat "$state_dir"/stopped-sha)"
0acb62f2 791
cf432ca0
MZ
792 require_clean_work_tree "rebase"
793 do_rest
794 ;;
cf432ca0 795skip)
cf432ca0 796 git rerere clear
cf432ca0 797
2959c283 798 do_rest
cf432ca0 799 ;;
eb9a7cb4
AW
800edit-todo)
801 sed -e '/^#/d' < "$todo" > "$todo".new
802 mv -f "$todo".new "$todo"
803 append_todo_help
804 cat >> "$todo" << EOF
805#
806# You are editing the todo file of an ongoing interactive rebase.
807# To continue rebase after editing, run:
808# git rebase --continue
809#
810EOF
811
812 git_sequence_editor "$todo" ||
813 die "Could not execute editor"
814
815 exit
816 ;;
cf432ca0 817esac
1b1dce4b 818
34262322
MZ
819git var GIT_COMMITTER_IDENT >/dev/null ||
820 die "You need to set your committer info first"
1b1dce4b 821
34262322
MZ
822comment_for_reflog start
823
71786f54 824if test ! -z "$switch_to"
34262322 825then
71786f54
MZ
826 output git checkout "$switch_to" -- ||
827 die "Could not checkout $switch_to"
34262322
MZ
828fi
829
431b7e78
MZ
830orig_head=$(git rev-parse --verify HEAD) || die "No HEAD?"
831mkdir "$state_dir" || die "Could not create temporary $state_dir"
34262322 832
431b7e78 833: > "$state_dir"/interactive || die "Could not mark as interactive"
84df4560 834write_basic_state
6bb4e485 835if test t = "$preserve_merges"
34262322 836then
6bb4e485 837 if test -z "$rebase_root"
34262322 838 then
6bb4e485 839 mkdir "$rewritten" &&
431b7e78 840 for c in $(git merge-base --all $orig_head $upstream)
acc8559a 841 do
6bb4e485 842 echo $onto > "$rewritten"/$c ||
34262322 843 die "Could not init rewritten commits"
acc8559a 844 done
34262322 845 else
6bb4e485
MZ
846 mkdir "$rewritten" &&
847 echo $onto > "$rewritten"/root ||
34262322
MZ
848 die "Could not init rewritten commits"
849 fi
850 # No cherry-pick because our first pass is to determine
851 # parents to rewrite and skipping dropped commits would
852 # prematurely end our probe
6bb4e485 853 merges_option=
34262322 854else
6bb4e485 855 merges_option="--no-merges --cherry-pick"
34262322
MZ
856fi
857
431b7e78 858shorthead=$(git rev-parse --short $orig_head)
6bb4e485
MZ
859shortonto=$(git rev-parse --short $onto)
860if test -z "$rebase_root"
861 # this is now equivalent to ! -z "$upstream"
34262322 862then
6bb4e485 863 shortupstream=$(git rev-parse --short $upstream)
431b7e78 864 revisions=$upstream...$orig_head
6bb4e485 865 shortrevisions=$shortupstream..$shorthead
34262322 866else
431b7e78 867 revisions=$onto...$orig_head
6bb4e485 868 shortrevisions=$shorthead
34262322 869fi
6bb4e485 870git rev-list $merges_option --pretty=oneline --abbrev-commit \
34262322 871 --abbrev=7 --reverse --left-right --topo-order \
6bb4e485 872 $revisions | \
34262322
MZ
873 sed -n "s/^>//p" |
874while read -r shortsha1 rest
875do
90e1818f
NH
876
877 if test -z "$keep_empty" && is_empty_commit $shortsha1
878 then
879 comment_out="# "
880 else
881 comment_out=
882 fi
883
6bb4e485 884 if test t != "$preserve_merges"
34262322 885 then
90e1818f 886 printf '%s\n' "${comment_out}pick $shortsha1 $rest" >>"$todo"
34262322
MZ
887 else
888 sha1=$(git rev-parse $shortsha1)
6bb4e485 889 if test -z "$rebase_root"
acc8559a 890 then
34262322
MZ
891 preserve=t
892 for p in $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)
acc8559a 893 do
12bf8283 894 if test -f "$rewritten"/$p
acc8559a 895 then
34262322 896 preserve=f
acc8559a
SH
897 fi
898 done
34262322
MZ
899 else
900 preserve=f
901 fi
902 if test f = "$preserve"
903 then
6bb4e485 904 touch "$rewritten"/$sha1
90e1818f 905 printf '%s\n' "${comment_out}pick $shortsha1 $rest" >>"$todo"
acc8559a 906 fi
34262322
MZ
907 fi
908done
d911d146 909
34262322 910# Watch for commits that been dropped by --cherry-pick
6bb4e485 911if test t = "$preserve_merges"
34262322 912then
6bb4e485 913 mkdir "$dropped"
34262322 914 # Save all non-cherry-picked changes
6bb4e485 915 git rev-list $revisions --left-right --cherry-pick | \
431b7e78 916 sed -n "s/^>//p" > "$state_dir"/not-cherry-picks
34262322
MZ
917 # Now all commits and note which ones are missing in
918 # not-cherry-picks and hence being dropped
6bb4e485 919 git rev-list $revisions |
34262322
MZ
920 while read rev
921 do
431b7e78 922 if test -f "$rewritten"/$rev -a "$(sane_grep "$rev" "$state_dir"/not-cherry-picks)" = ""
34262322
MZ
923 then
924 # Use -f2 because if rev-list is telling us this commit is
925 # not worthwhile, we don't want to track its multiple heads,
926 # just the history of its first-parent for others that will
927 # be rebasing on top of it
6bb4e485 928 git rev-list --parents -1 $rev | cut -d' ' -s -f2 > "$dropped"/$rev
34262322 929 short=$(git rev-list -1 --abbrev-commit --abbrev=7 $rev)
6bb4e485
MZ
930 sane_grep -v "^[a-z][a-z]* $short" <"$todo" > "${todo}2" ; mv "${todo}2" "$todo"
931 rm "$rewritten"/$rev
34262322
MZ
932 fi
933 done
934fi
935
6bb4e485
MZ
936test -s "$todo" || echo noop >> "$todo"
937test -n "$autosquash" && rearrange_squash "$todo"
c2145384
LK
938test -n "$cmd" && add_exec_commands "$todo"
939
6bb4e485 940cat >> "$todo" << EOF
6047a234 941
6bb4e485 942# Rebase $shortrevisions onto $shortonto
fcc5ef1c
AW
943EOF
944append_todo_help
945cat >> "$todo" << EOF
1b1dce4b 946#
6047a234 947# However, if you remove everything, the rebase will be aborted.
82576ddb 948#
1b1dce4b 949EOF
1b1dce4b 950
90e1818f
NH
951if test -z "$keep_empty"
952then
953 echo "# Note that empty commits are commented out" >>"$todo"
954fi
955
956
6bb4e485 957has_action "$todo" ||
34262322 958 die_abort "Nothing to do"
1b1dce4b 959
6bb4e485 960cp "$todo" "$todo".backup
821881d8 961git_sequence_editor "$todo" ||
34262322 962 die_abort "Could not execute editor"
1b1dce4b 963
6bb4e485 964has_action "$todo" ||
34262322 965 die_abort "Nothing to do"
c54b7817 966
6bb4e485 967test -d "$rewritten" || test -n "$force_rebase" || skip_unnecessary_picks
0e757e30 968
6bb4e485 969output git checkout $onto || die_abort "could not detach HEAD"
431b7e78 970git update-ref ORIG_HEAD $orig_head
34262322 971do_rest